﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager;
using Infragistics.Windows;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using System.ComponentModel;

namespace Dock1
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {
        public MainWindow()
        {
            InitializeComponent();
            Data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data d = new Data()
                {
                    ID = i,
                    Name = "Name 1: " + i,
                    AccountName = "AccountName 1:" + i,
                    Class = "Class 1:" + i,
                    Amount = 7*i,
                    ChildData = new ObservableCollection<Data>()
                };

                for (int j = 0; j < 10; j++)
                {
                    Data d1 = new Data()
                    {
                        ID = j,
                        Name = "Name 2: " + j,
                        AccountName = "ChildAccountName 2:" + j,
                        Class = "ChildClass 2:" + j,
                        Amount = 2*j,
                        ChildData = new ObservableCollection<Data>()
                    };                    

                    d.ChildData.Add(d1);
                }
                Data.Add(d);
            }

            CollectionData = CollectionViewSource.GetDefaultView(Data);
            DataContext = this;
        }

        private void xamDataGrid1_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {
            FieldLayout resultLayout = new FieldLayout();

            if (e.ParentExpandableFieldRecord == null)
                resultLayout = xamDataGrid1.FieldLayouts["parent"];
            else
                resultLayout = xamDataGrid1.FieldLayouts["child"];

            e.FieldLayout = resultLayout;
        }

        private ICollectionView collectionData;
        public ICollectionView CollectionData
        {
            get { return collectionData; }
            set
            {
                collectionData = value;
                NotifyPropertyChanged("CollectionData");
            }
        }

        public ObservableCollection<Data> Data { get; set; }

        private void xamDockManager1_Loaded(object sender, RoutedEventArgs e)
        {
            ContentPane pane = Utilities.GetDescendantFromType(sender as DependencyObject, typeof(ContentPane), false) as ContentPane;
            pane.Activate();

        }

        private void xamDataGrid1_SummaryResultChanged(object sender, Infragistics.Windows.DataPresenter.Events.SummaryResultChangedEventArgs e)
        {

        }

        private void NotifyPropertyChanged(string name)
        {
            if (null != PropertyChanged)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(name));
            }
        }


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion
    }

    //public class Data
    //{
    //    public int ID { get; set; }
    //    public string Name { get; set; }
    //    public string AccountName { get; set; }
    //    public string Class { get; set; }
    //    public ObservableCollection<Data> ChildData { get; set; }
    //}
}
